Package org.picocontainer.containers

# Class CompositePicoContainer

java.lang.Object
org.picocontainer.containers.CompositePicoContainer

All Implemented Interfaces:
  `Serializable`, `Converting`, `PicoContainer`

public class CompositePicoContainer extends Object implements PicoContainer, Converting, Serializable
CompositePicoContainer takes a var-args list of containers and will query them in turn for getComponent(*) and getComponentAdapter(*) requests. Methods returning lists and getParent/accept will not function.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`CompositePicoContainer.CompositeConverters`

## Constructor Summary

Constructors
Constructor
Description
`CompositePicoContainer(PicoContainer... containers)`

## Method Summary

Modifier and Type
Method
Description
`void`
`accept(PicoVisitor visitor)`
Accepts a visitor that should visit the child containers, component adapters and component instances.
`<T> T`
`getComponent(Class<T> componentType)`
Retrieve a component keyed by the component type.
`<T> T`
`getComponent(Class<T> componentType, Class<? extends Annotation> binding)`
Retrieve a component keyed by the component type and binding type.
`Object`
`getComponent(Object componentKeyOrType)`
Retrieve a component instance registered with a specific key or type.
`Object`
`getComponent(Object componentKeyOrType, Type into)`
`<T> ComponentAdapter<T>`
`getComponentAdapter(Class<T> componentType, Class<? extends Annotation> binding)`
Find a component adapter associated with the specified type and binding type.
`<T> ComponentAdapter<T>`
`getComponentAdapter(Class<T> componentType, NameBinding nameBinding)`
Find a component adapter associated with the specified type and binding name.
`ComponentAdapter`
`getComponentAdapter(Object componentKey)`
Find a component adapter associated with the specified key.
`Collection<ComponentAdapter<?>>`
`getComponentAdapters()`
Retrieve all the component adapters inside this container.
`<T> List<ComponentAdapter<T>>`
`getComponentAdapters(Class<T> componentType)`
Retrieve all component adapters inside this container that are associated with the specified type.
`<T> List<ComponentAdapter<T>>`
`getComponentAdapters(Class<T> componentType, Class<? extends Annotation> binding)`
Retrieve all component adapters inside this container that are associated with the specified type and binding type.
`List<Object>`
`getComponents()`
Retrieve all the registered component instances in the container, (not including those in the parent container).
`<T> List<T>`
`getComponents(Class<T> componentType)`
Returns a List of components of a certain componentType.
`Converters`
`getConverters()`
Retrieve the set of converters for transforming string parameters into objects.
`PicoContainer`
`getParent()`
Retrieve the parent container of this container.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### CompositePicoContainer

public CompositePicoContainer(PicoContainer... containers)

## Method Details

### getComponent

public <T> T getComponent(Class<T> componentType)
Description copied from interface: `PicoContainer`
Retrieve a component keyed by the component type.

Specified by:
  `getComponent` in interface `PicoContainer`
Parameters:
  `componentType` - the type of the component
Returns:
  the typed resulting object instance or null if the object does not exist.

### getComponent

public Object getComponent(Object componentKeyOrType, Type into)

Specified by:
  `getComponent` in interface `PicoContainer`

### getComponent

public Object getComponent(Object componentKeyOrType)
Description copied from interface: `PicoContainer`
Retrieve a component instance registered with a specific key or type. If a component cannot be found in this container, the parent container (if one exists) will be searched.

Specified by:
  `getComponent` in interface `PicoContainer`
Parameters:
  `componentKeyOrType` - the key or Type that the component was registered with.
Returns:
  an instantiated component, or `null` if no component has been registered for the specified key.

### getComponentAdapter

public ComponentAdapter getComponentAdapter(Object componentKey)
Description copied from interface: `PicoContainer`
Find a component adapter associated with the specified key. If a component adapter cannot be found in this container, the parent container (if one exists) will be searched.

Specified by:
  `getComponentAdapter` in interface `PicoContainer`
Parameters:
  `componentKey` - the key that the component was registered with.
Returns:
  the component adapter associated with this key, or `null` if no component has been registered for the specified key.

### getComponentAdapter

public <T> ComponentAdapter<T> getComponentAdapter(Class<T> componentType, NameBinding nameBinding)
Description copied from interface: `PicoContainer`
Find a component adapter associated with the specified type and binding name. If a component adapter cannot be found in this container, the parent container (if one exists) will be searched.

Specified by:
  `getComponentAdapter` in interface `PicoContainer`
Parameters:
  `componentType` - the type of the component.
  `nameBinding` - the name binding to use
Returns:
  the component adapter associated with this class, or `null` if no component has been registered for the specified key.

### getComponentAdapter

public <T> ComponentAdapter<T> getComponentAdapter(Class<T> componentType, Class<? extends Annotation> binding)
Description copied from interface: `PicoContainer`
Find a component adapter associated with the specified type and binding type. If a component adapter cannot be found in this container, the parent container (if one exists) will be searched.

Specified by:
  `getComponentAdapter` in interface `PicoContainer`
Parameters:
  `componentType` - the type of the component.
  `binding` - the typed binding to use
Returns:
  the component adapter associated with this class, or `null` if no component has been registered for the specified key.

### getComponent

public <T> T getComponent(Class<T> componentType, Class<? extends Annotation> binding)
Description copied from interface: `PicoContainer`
Retrieve a component keyed by the component type and binding type.

Specified by:
  `getComponent` in interface `PicoContainer`
Parameters:
  `componentType` - the type of the component
  `binding` - the binding type of the component
Returns:
  the typed resulting object instance or null if the object does not exist.

### getComponents

public List<Object> getComponents()
Description copied from interface: `PicoContainer`
Retrieve all the registered component instances in the container, (not including those in the parent container). The components are returned in their order of instantiation, which depends on the dependency order between them.

Specified by:
  `getComponents` in interface `PicoContainer`
Returns:
  all the components.

### getParent

public PicoContainer getParent()
Description copied from interface: `PicoContainer`
Retrieve the parent container of this container.

Specified by:
  `getParent` in interface `PicoContainer`
Returns:
  a `PicoContainer` instance, or `null` if this container does not have a parent.

### getComponentAdapters

public Collection<ComponentAdapter<?>> getComponentAdapters()
Description copied from interface: `PicoContainer`
Retrieve all the component adapters inside this container. The component adapters from the parent container are not returned.

Specified by:
  `getComponentAdapters` in interface `PicoContainer`
Returns:
  a collection containing all the `ComponentAdapter`s inside this container. The collection will not be modifiable.
See Also:
  - `a variant of this method which returns the component adapters inside this container that are associated with the specified type.`

### getComponentAdapters

public <T> List<ComponentAdapter<T>> getComponentAdapters(Class<T> componentType)
Description copied from interface: `PicoContainer`
Retrieve all component adapters inside this container that are associated with the specified type. The addComponent adapters from the parent container are not returned.

Specified by:
  `getComponentAdapters` in interface `PicoContainer`
Parameters:
  `componentType` - the type of the components.
Returns:
  a collection containing all the `ComponentAdapter`s inside this container that are associated with the specified type. Changes to this collection will not be reflected in the container itself.

### getComponentAdapters

public <T> List<ComponentAdapter<T>> getComponentAdapters(Class<T> componentType, Class<? extends Annotation> binding)
Description copied from interface: `PicoContainer`
Retrieve all component adapters inside this container that are associated with the specified type and binding type. The addComponent adapters from the parent container are not returned.

Specified by:
  `getComponentAdapters` in interface `PicoContainer`
Parameters:
  `componentType` - the type of the components.
  `binding` - the typed binding to use
Returns:
  a collection containing all the `ComponentAdapter`s inside this container that are associated with the specified type. Changes to this collection will not be reflected in the container itself.

### getComponents

public <T> List<T> getComponents(Class<T> componentType)
Description copied from interface: `PicoContainer`
Returns a List of components of a certain componentType. The list is ordered by instantiation order, starting with the components instantiated first at the beginning.

Specified by:
  `getComponents` in interface `PicoContainer`
Parameters:
  `componentType` - the searched type.
Returns:
  a List of components.

### accept

public void accept(PicoVisitor visitor)
Description copied from interface: `PicoContainer`
Accepts a visitor that should visit the child containers, component adapters and component instances.

Specified by:
  `accept` in interface `PicoContainer`
Parameters:
  `visitor` - the visitor

### getConverters

public Converters getConverters()
Description copied from interface: `Converting`
Retrieve the set of converters for transforming string parameters into objects.

Specified by:
  `getConverters` in interface `Converting`
Returns:
  converter set instance.